***********1.Definition of sets for suffix ------------------
Sets
i    SECTORS
/
agric       Agriculture
crudeoil    oil and gas
food        Manufacture of foods tobacco
texti       Manufacture of textile
woodpaper   Processing of timber  Manufacture of furniture paper
chemical    Chemical industry
mineral     Manufacture of non-metallic mineral products
metal       Manufacture of metal products
machi       Manufacture of general special purpose machinery
commu       Manufacture of communication equipment other electronic equipment
const       Construction
trans       Transport storage  post
service

petr       Processing of petroleum of nuclear fuel
gas        Production  distribution of gas
pow        power

/

oths(i)
/
agric
crudeoil
food
texti
woodpaper
chemical
mineral
metal
machi
commu
const
trans
service
/

t(i)
/
agric       Agriculture
crudeoil    oil and gas
food        Manufacture of foods tobacco
texti       Manufacture of textile
woodpaper   Processing of timber  Manufacture of furniture paper
chemical    Chemical industry
mineral     Manufacture of non-metallic mineral products
metal       Manufacture of metal products
machi       Manufacture of general special purpose machinery
commu       Manufacture of communication equipment other electronic equipment
const       Construction
trans       Transport storage  post
service

petr       Processing of petroleum of nuclear fuel
gas        Production  distribution of gas
pow        power

/

u(i)
/
agric       Agriculture
crudeoil    oil and gas
food        Manufacture of foods tobacco
texti       Manufacture of textile
woodpaper   Processing of timber  Manufacture of furniture paper
chemical    Chemical industry
mineral     Manufacture of non-metallic mineral products
metal       Manufacture of metal products
machi       Manufacture of general special purpose machinery
commu       Manufacture of communication equipment other electronic equipment
const       Construction
trans       Transport storage  post
service

petr       Processing of petroleum of nuclear fuel
pow        power
/

gi(i)
/gas       Production  distribution of gas/



m(i)
/
agric       Agriculture
crudeoil    oil and gas
food        Manufacture of foods tobacco
texti       Manufacture of textile
woodpaper   Processing of timber  Manufacture of furniture paper
chemical    Chemical industry
mineral     Manufacture of non-metallic mineral products
metal       Manufacture of metal products
machi       Manufacture of general special purpose machinery
commu       Manufacture of communication equipment other electronic equipment
const       Construction
trans       Transport storage  post
service

petr       Processing of petroleum of nuclear fuel
pow        power

/

n(i)    /gas /

nfe(i)
/agric,crudeoil,food,texti,woodpaper,chemical,mineral,metal,machi,commu,
const,trans,service,pow/

fe(i)  /petr,gas/

Alias(i,j) ;


******** **2.Parameter Definition ----------------------------------
*******2.1 Base year variable Definition---------------------------------
Parameter

QX0(i)           Output of the i-th sector in base year
ND0(i)           Intermediate input of the i-th sector in base year
UND0(oths,i)     Unit intermediate input in base year
KEL0(i)          Capital-Energy-Labor composite factor input in base year
L0(i)            Labor factor input in base year
KE0(i)           Capital-Energy composite factor input in base year
K0(i)            Capital factor input in base year

E0(i)            Energy composite factor input in base year
Epow0(i)         Energy  factor input of power in base year
Epg0(i)          Energy  factor input of petr and gas in base year
Epetr0(i)        Energy  factor input of petr in base year
Egas0(i)         Energy  factor input of gas in base year

PX0(i)           Price of the i-th sector in base year
PND0(i)          Price of the intermediate input the i-th sector in base year
PKEL0(i)         Price of the Capital-Energy-Labor composite factor in base year
PKE0(i)          Price of the Capital-Energy composite factor in base year

WL0              Relatively Price of the Labor factor  in base year
PL0(i)
wldist(i)

WK0              Relatively Price of the Capital factor in base year
PK0(i)
wrdist(i)

dept(i)
DEPRE0(i)

PE0(i)           Price of the Energy composite factor in base year
PEpg0(i)         Price of the petr-gas composite factor in base year
PEgas0(i)        Price of the gas composite factor in base year
PEpetr0(i)       Price of the petr composite factor in base year
PEpow0(i)        Price of the power composite factor in base year

QQ0(j)           Armington's composite good in base year
QD0(j)           Armington's domestic good CET's domestic good in base year
QM0(j)           Imports good in base year

QE0(j)           Exports good in base year
PQ0(j)           Armington's composite good price in base year
PM0(j)           Import price in local currency in base year
PE0(j)           Export price in local currency in base year
PD0(j)           The j-th domestic good price in base year
EXR0             Exchange rate in base year
PWM0(j)          Import international price in base year
PWE0(j)          Export international price in base year

YH0(i)          the income of household labor income from the i-th sector in base year
TYL0            the total income of household from labor in base year
YHK0            the total income of household from capital in base year
YHW0            the total income of household from foreign in base year
YHT0            the total income of household in base year
SH0             the saving of household in base year
HD0(j)          the consumption of household to the i-th good in base year

YK0(i)          the income of capital from the i-th sector in base year
TYK0            the total income from capital in base year
YWK0            the income of foreign from capital in base year
YEK0            the income of enterprise capital in base year
YEH0            the transfer payments of the enterprise to household in base year
SE0             the saving of enterprise in base year
INV0(j)         the investing of the j-th good in base year

GINDTAX0(j)     the income of government from the i-th sector indirect tax in
GTRIFM0(j)      the income of government from the i-th good tariff tax in base
GHTAX0          the income of government from household income tax in base year
GETAX0          the income of government from enterprise income tax in base year
GWY0            the income of government from foreign in base year
YGT0            the total income of government in base year
YHG0            the transfer payments of government to household in base year
YWG0            the payments of government to foreign in base year
SG0             the saving of government in base year
GD0(j)          the consumption of government to the j-th good in base year

SF0             the saving of foreign in base year
TINV0           the total investing in base year
TSAV0           the total saving in base year
LS0             total Labor supply in base year
KS0             total Capital supply in base year
RGDP0           the real GDP in base year
SGDP0(i)        the nominal GDP of the i-th sector in base year
GDP0            the nominal GDP in base year in base year
PGDP0           the GDP price index in base year
WALRAS0         the walras in base year

QET0(n)

EP0

** ADDED FACTOR OF IRAN SAM

YWL0

YKW0

YHH0

EHY0

YGC0

GGTAX0

YLW0

YWH0

YAI0

**

*********2.2 Elasticity Parameters Definition -------------------------------------
rhoQX(i)   Elasticity of substitution in the intermediate input and adding input
rhoKEL(i)  Elasticity of substitution in the captial-energy and labor input
rhoKE(i)   Elasticity of substitution in the captial and energy input
rhoE(i)    Elasticity of substitution in the fossil and power input
rhoPG(i)   Elasticity of substitution in the petr and gas input
rhopetr(i) Elasticity of substitution in the petr input
rhogas(i)  Elasticity of substitution in the gas input
rhopow(i)  Elasticity of substitution in the power input

parQX(i)
parKEL(i)
parKE(i)
parE(i)
parPG(i)
parpetr(i)
pargas(i)
parpow(i)

rhoQq(j)        Elasticity parameter in the Arminton function
rhoCET(j)       Elasticity parameter in the CET function
etaQq(j)        The parameter about the Arminton function elasticity parameter
phiCET(j)       The parameter about the CET function elasticity parameter

**ADD GAS MARKET

ECON

PET

pett

qer

MC

ETA

SHARE

PREG

rateEP



*********2.3 Share Parameter Definition ---------------------------------
deltaKEL(i)      KEL Share parameter in  production function
deltaND(i)       ND Share parameter in  production function

scaleKEL(i)
deltaKE(i)       KE Share parameter in  production function
deltaL(i)        L Share parameter in  production function

scaleKE(i)
deltaE(i)        E Share parameter in  production function
deltaK(i)        K Share parameter in  production function

deltafos(i)      fossil energy share parameter in production function

deltapg(i)       petr-gas composite energy share parameter in production function
deltapow(i)      power energy share parameter in production function

deltapetr(i)     petr composite energy share parameter in production function
deltagas(i)      gas composite energy share parameter in production function

scaleQQ(j)       Scale parameter in the Armington function
deltaQM(j)       QM Share parameter in the Armington function
deltaQD(j)       QD Share parameter in the Armington function
scaleCET(j)      Scale parameter in the CET function
deltaQE(j)       QE Share parameter in the CET function
deltaQDs(j)      QDs Share parameter in the CET function

*********2.4 Other Parameter Definitions ---------------------------------
TFP(i)           production function total factors efficiency of the i-th sector
TFEP(i)          energy efficiency of the i-th sector

TFWP(i)          the wind energy efficiency of the i-th sector
TFOP(i)          the others energy efficiency of the i-th sector

ca(oths,i)       intermediate input parameters
tm(j)            the rate of import tariff of the j-th good
ratehk           the rate of household capital income in total capital income
ratehw           the rate of household income from foreign
savh             the rate of household's savings
conh(j)          the rate of household's consumption to the j-th good
ratewk           the rate of foreign capital income in total capital income
ratehe           the rate of enterprise to household in enterprise total capital
invest(j)        the rate of investing to the j-th good
tind(i)          the rate of production tax to the i-th sector
th               the rate household income tax
te               the rate enterprise income tax
rategw           the rate of Government income from foreign
ratehg           the rate of government to household in total government income
ratewg           the rate of government to foreign in total government income
savg             the rate of government's savings
cong(j)          the rate of government consumption to j-th good

LHD0(i)          the lowerst demand of household
THD0             the total demand of household
hdye(i)          the household  demand elasticity parameters  of income
frisch           frisch parameter
hds(i)           the consumption share of household
mpci(i)          intial marginal propensity to consume
tmcpi            the  total  intial marginal propensity to consume
mpc(i)           the adjustment marginal propensity to consume


** ADDED FACTORS OF IRAN SAM

ratehl

ratekw

ratehh

ratehe

rateGC

tg

ratelw

ratewh

rateai

**

OPTION   DECIMALS=4;

***********3 Variable and Parameters initialization-----------------

TABLE  UND0(oths,i)  Intermediate input dates in base year

              Agric          crudeoil         Food           Texti         WoodPaper        Chemical        Mineral          Metal            Machi          commu            Const          Trans           service           gas            petr            POW
Agric      155805687.2     1020760.168     265806067.5     8467702.183     1844027.475     3913440.818     1332652.145     268039.1469     376056.3172     55961.20322     1138742.171     104160.1289     12286774.35     18483.78577     656421.2668     6436.515738
crudeoil   405979.6907     179941.6693     86803.22752     11212.41494     29957.39568     509899.6322     5984276.386     24821338.63     1683940.839     14199.71827     6402001.709     9228.339907     703091.3886     237854.5525     80924840.42     621.7125001
Food       40270459.5      211487.5669     31440130.43     756494.1353     390512.5663     5509453.233     1292021.569     3052825.004     4045647.373     353143.7769     298928.5101     248827.0873     32463868.77     17357.07606     2083478.916     11320.10687
Texti      1751807.151     54588.67955     943937.3744     17805676.87     158735.222      4395457.998     620009.8334     1161380.689     3111633.562     162762.5494     1006568.437     139825.8341     3302060.832     11882.52129     825839.1773     3654.318987
WoodPaper  1669530.958     40184.7931      2235251.592     187230.2818     7400982.443     4259226.014     1734440.481     1452109.478     5536192.06      499890.405      5120605.22      80738.95903     6847037.425     10320.59655     1119038.951     13130.99242
Chemical   29793453.82     2368717.111     4156926.624     8871987.59      3293654.074     136143777.2     8304172.996     9626179.822     27775887.29     7931307.953     10420716.55     11247711.08     26378835.19     103434.3615     109759417.7     44352.98429
Mineral    747187.3011     337547.6689     1662159.4       78640.15731     171407.3076     3292046.167     6456267.133     5208120.324     5941242.291     571716.6506     81920142.15     68910.00096     12675999.39     43415.13659     2989627.641     12884.62418
Metal      2274026.713     338914.6405     2087047.821     606554.0658     1053991.53      6246947.89      5590082.899     132589184.3     72251625.46     15156738.07     113048365.2     482897.7697     9838793.531     37139.64442     12643078.5      169930.4587
Machi      2635274.628     370607.8803     475929.6689     363586.9311     1109905.309     2100534.258     1757202.836     5975476.479     143417791       805176.943      9117992.366     2161490.627     22011262.68     69222.34287     2272772.244     19248.28056
commu      514443.3399     394748.0353     102059.1661     68449.70107     207013.5808     1115892.779     480305.8444     1485039.298     5801654.807     9567738.305     11231212        86098.36696     6628856.874     56062.28339     1084001.28      5032.636872
Const      1171277.611     543237.8481     220260.6105     44347.2851      107922.4819     1228358.483     1803343.915     794620.6804     394693.2354     99304.78182     43334506.71     562634.6249     62171155.82     4620.241016     1594042.276     44548.36854
Trans      20877019.93     1494837.689     12444231.27     1413297.429     1603227.396     10279728.3      15604118.04     26249763.76     13793407.68     1991489.827     55159648.38     7238710.451     42966699.41     90558.65451     22691977.98     43638.0212
service    58241468.43     16174591.49     38025633.56     8775088.016     6467826.515     50514819.78     23534514.24     60805574.48     86036993.65     14557075.17     106391482.7     32082254.77     241300115.2     1128603.957     90581060.65     6746560.483


;
ND0(i)= sum(oths,UND0(oths,i));

TABLE   secda1(i,*)   Energy dates of sectors in base year

                 gas           petr              pow
Agric        1575122.12      38475957.58     4130760.737
crudeoil     1909934.982     10874617.45     4137819.044
Food         1767349.723     1280175.701     1729842.427
Texti        293124.7129     371954.0803     1161813.208
WoodPaper    288807.9107     422845.4005     560242.2512
Chemical     63161187.96     12738928.91     4099502.864
Mineral      6454461.007     5931553.991     5867210.308
Metal        4395747.901     3552861.933     9849599.734
Machi        618279.1831     9415637.846     1418909.541
commu        126289.6643     699937.4719     365696.6202
Const        290817.8253     36535261.06     694784.6669
Trans        718080.9118     99895576.86     682402.67
service      78602924.34     146088643.6     51607953.12
petr         16115817.11     556229.7372     225876.7147
gas          2037037.631     4784042.572     955229.4361
pow          10074479.29     1408245.918     8828624.969

;

Egas0(i)=secda1(i,"gas");
Epetr0(i)=secda1(i,"petr");
Epow0(i)=secda1(i,"pow");

TABLE   secda2(i,*)   Sectors dates in base year

                   QD                 QE                QM               GINDTAX            GTRIFM            HD                GD               YH             dept        DEPRE            YK              INV               SGDP         PX    TFP0     HDYE
Agric         876019410.0518     67087976.2431       76356393.9507     -7912429.0000     6104392.0000    277923702.8370     6933806.6316     447466747.0574     0.05      60752824.29     60752824.29     138060488.2     500307142.3514     1     1     0.5642
crudeoil      76886712.6258      1019411087.5677     3229364.1606       7339372.0000     105575.0000     793045.1231        0.0000           54080471.8062      0.062     176755477.7     965641612      -45911520.22     1027061455.8029    1     1     0.9603
Food          142480410.4909     43199494.2253       157808581.6506     606718.0000      2950205.0000    415774659.9365     0.0000           47977056.5545      0.065     13438121.88     56628046.64     56123495.09     105211821.1951     1     1     0.5642
Texti         594344110.6482     28086638.3203       84456222.2242      221919.0000      2354492.0000    120836374.0069     0.0000           20020190.8150      0.065     2377485.657     6921627.082    -20146709.93     27163736.8969      1     1     1.0128
WoodPaper     136145485.1254     1179518.2794        40090033.6860      5483979.0000     -3049010.0000   14992052.1936      0.0000           8122444.8378       0.065     2013413.408     5751664.86      27382486.63     19358088.6978      1     1     1.0485
Chemical      80580449.4739      183194792.3885      176979547.6823     4455470.0000     1594476.0000    74747177.5811      0.0000           34802725.7566      0.055     36942573.77     108441252.1    -14869706.11     147699447.8238     1     1     0.9603
Mineral       456098003.8244     25803822.3664       15105928.1413      8532753.0000     2133361.0000    11443393.1900      0.0000           39079416.2823      0.055     13197659.19     43630870.23     8859703.951     91243039.5164      1     1     0.9603
Metal         378614200.0440     53617100.6673       152543448.7056     3874568.0000     8987673.0000    12020837.2877      0.0000           48769425.2808      0.055     34406469.99     80304127.53     145713848.1     132948120.8061     1     1     0.9603
Machi         532150003.8365     32719283.0860       341004092.1723     878429.0000      0.0000          152428224.1516     0.0000           56312268.3130      0.055     20366077.86     75911315.48     511243568.5     133102012.7903     1     1     1.0485
commu         228947634.3341     7375562.4736        148022921.6659     6436687.0000     38267423.0000   23068995.3233      0.0000           12430406.4032      0.55      3159363.771     14414611.46     167050030.7     33281704.8595      1     1     2.1305
Const         858335267.1147     0.00001             0.0000             3608640.0000     0.0000          10670860.0669      5329.9311        148938213.4030     0.055     37267994.47     183401806       696389416.8     335948659.4360     1     1     0.9603
Trans         474870854.7445     60585651.9902       52460025.1598      2341272.0000     0.0000          161034103.6168     0.0000           234761997.4039     0.055     32435981.43     88816295.89     79894396.91     325919565.2967     1     1     2.1305
service       269440940.0001     56444451.7296       107138761.1969     20276690.0000    0.0000          1444067412.5136    674782341.8315   1506983831.3048    0.055     475252239.5     1221770748      595495725.2     2749031269.4436    1     1     1.139
petr          106974889.7797     78325375.9999       0.0000             1624792.0000     5055583.0000    80066617.4677      0.0000           105295947.9063     0.055     54959142.25     221402216.9     944860.2499     328322956.7794     1     1     0.9603
gas           821184481.7324     234811047.6470      57192353.5572      6732687.0000     0.0000          129870788.6832     0.0000           17029698.9260      0.048     43277538.78     199766322.3    -124289058.8     223528708.2380     1     1     0.9603
pow           3555709142.6864    14981443.5357       0.0000             217847.0000      0.0000          29657351.3304      0.0000           21642480.3398      0.048     21112202.97     72002714.19    -18998729.87     93863041.5308      1     1     0.9603


;

QD0(i)=secda2(i,"QD");
QE0(i)=secda2(i,"QE");
QM0(i)=secda2(i,"QM");
GINDTAX0(i)=secda2(i,"GINDTAX");
GTRIFM0(i)=secda2(i,"GTRIFM");
HD0(i)=secda2(i,"HD");
GD0(i)=secda2(i,"GD");

L0(i)=secda2(i,"YH");
YH0(i)=secda2(i,"YH");

dept(i)=secda2(i,"dept");
DEPRE0(i)=secda2(i,"DEPRE");
YK0(i)=secda2(i,"YK");

INV0(i)=secda2(i,"INV");
SGDP0(i)=secda2(i,"SGDP");

PX0(i)=secda2(i,"PX");
TFP(i)=secda2(i,"TFP0");

hdye(i)=secda2(i,"hdye");

PL0(i)=YH0(i)/L0(i);
WL0=sum(i,YH0(i))/sum(i,L0(i));
wldist(i)=PL0(i)/WL0;

K0(i)=DEPRE0(i)/dept(i);
PK0(i)=YK0(i)/K0(i);
WK0=sum(i,YK0(i))/sum(i,K0(i));
wrdist(i)=PK0(i)/WK0;

Parameter secda3(*)
/
EXR=1
TYL=2803713322

YHK=695770735.237
YHW=4467266.38
YHT=3848764374

SH=844329858

YWK=13712365.80
YEK=2584135264.80

YEH=0
SE=1861921266.69
GHTAX=3446122.47
GETAX=726170000.00
GWY=0
YGT=994879558

YHG=315426344.56
YWG=0
SG=-6516265.00
SF=0
PGDP=1
WALRAS=0
frisch=-3

**ADDED FACTOR OF IRAN SAM

YWL=3950705

YKW=19852182

YHH=31991277

EHY=3956001

YGC=131791871

GGTAX=4248000

YLW=6555276

YWH=5645519

YAI=496792564

**

/
;

EXR0=secda3("EXR");
TYL0= secda3("TYL");
YHK0= secda3("YHK");
YHW0= secda3("YHW");
YHT0= secda3("YHT ");
SH0= secda3("SH");
YWK0= secda3("YWK");
YEK0= secda3("YEK");
YEH0= secda3("YEH");
SE0= secda3("SE");
GHTAX0= secda3("GHTAX");
GETAX0= secda3("GETAX");
GWY0= secda3("GWY");
YGT0= secda3("YGT");
YHG0= secda3("YHG");
YWG0= secda3("YWG");
SG0= secda3("SG");
SF0=secda3("SF");
PGDP0=secda3("PGDP");
WALRAS0=secda3("WALRAS");
frisch=secda3("frisch");

**ADDED FACTOR OF IRAN SAM

YWL0= secda3("YWL");

YKW0= secda3("YKW");

YHH0= secda3("YHH");

EHY0= secda3("EHY");

YGC0= secda3("YGC");

GGTAX0= secda3("GGTAX");

YLW0= secda3("YLW");

YWH0= secda3("YWH");

YAI0= secda3("YAI");

**

THD0=sum(i,HD0(i));
hds(i)=HD0(i)/THD0;
mpci(i)=hds(i)*hdye(i);
tmcpi=sum(i,mpci(i));
mpc(i)=mpci(i)/tmcpi;
LHD0(i)=HD0(i)+mpc(i)*THD0/PX0(i)/frisch;

Epg0(i)=Epetr0(i)+Egas0(i);

E0(i)=Epg0(i)+Epow0(i);

KE0(i)=WK0*wrdist(i)*K0(i)+E0(i);

KEL0(i)=KE0(i)+WL0*wldist(i)*L0(i);

QX0(j)=KEL0(j)+ND0(j);

PND0(i)=PX0(i);
PKEL0(i)=PX0(i);
PKE0(i)=PX0(i);
PE0(i)=PX0(i);
PEpg0(i)=PX0(i);
PEpow0(i)=PX0(i);
PEgas0(i)=PX0(i);

TFEP(i)=TFP(i);
TFWP(i)=TFP(i);
TFOP(i)=TFP(i);

PD0(j)= PX0(j);
PQ0(j)=PX0(j);
PWM0(i)=PX0(i);
PWE0(i)=PX0(i);

TYK0=sum(i,YK0(i));

TINV0=sum(i,INV0(i));
TSAV0=SE0+SH0+SG0+SF0;
LS0=sum(i,L0(i));
KS0=sum(i,K0(i));
RGDP0=sum(i,HD0(i))+sum(i,GD0(i))+sum(i,INV0(i))+sum(i,QE0(i))
     -sum(i,QM0(i))-sum(j,GTRIFM0(j));
GDP0=sum(i,SGDP0(i));


TABLE   elast(*,i)  Elasticity dates

              agric        crudeoil      food         texti      woodpaper     chemical     mineral       metal        machi        commu        const        trans       service        petr         gas          pow
rhoQX          3             3            3            3            3            3            3            3            3            3            3            3            3            3            3            3
rhoKEL         0.8          0.8          0.8          0.8          0.8          0.8          0.8          0.8          0.8          0.8          0.8          0.8          0.8          0.8          0.8          0.8
rhoKE          0.6          0.6          0.6          0.6          0.6          0.6          0.6          0.6          0.6          0.6          0.6          0.6          0.6          0.6          0.6          0.6
rhoE           1.2          1.2          1.2          1.2          1.2          1.2          1.2          1.2          1.2          1.2          1.2          1.2          1.2          1.2          1.2          1.2
rhoPG          1.3          1.3          1.3          1.3          1.3          1.3          1.3          1.3          1.3          1.3          1.3          1.3          1.3          1.3          1.3          1.3
rhogas         1.6          1.6          1.6          1.6          1.6          1.6          1.6          1.6          1.6          1.6          1.6          1.6          1.6          1.6          1.6          1.6
rhopetr        1.25         1.25         1.25         1.25         1.25         1.25         1.25         1.25         1.25         1.25         1.25         1.25         1.25         1.25         1.25         1.25
rhopow          3            3            3            3            3            3            3            3            3            3            3            3            3            3            3            3
rhoQq           3           2.5          2.5          2.5          2.5          2.5          2.5          2.5          2.5          2.5           2            2            2           2.5          2.5          1.1
rhoCET          4           2.5          3.5          3.5          3.5          3.5          3.5          3.5          3.5          3.5           3            3           2.5          0.5          3.5          0.5

;

rhoQX(i)=elast("rhoQX",i);
rhoKEL(i)=elast("rhoKEL",i);
rhoKE(i)=elast("rhoKE",i);
rhoE(i)=elast("rhoE",i);
rhoPG(i)=elast("rhoPG",i);

rhogas(i)=elast("rhogas",i);
rhopetr(i)=elast("rhopetr",i);
rhopow(i)=elast("rhopow",i);

rhoQq(i)=elast("rhoQq",i);
rhoCET(i)=elast("rhoCET",i);

***********4 Parameters Calibration---------------------------

ca(oths,i)=UND0(oths,i)/ND0(i);
tm(j)$(QM0(j)<>0)=GTRIFM0(j)/QM0(j) ;
tm(j)$(QM0(j)=0)=0;
tind(i)=GINDTAX0(i)/QX0(i);

ratehk=YHK0/TYK0;
ratehw=YHW0/sum(i,QM0(i));
savh=SH0/(TYL0+YHK0+YEH0+YHG0+YHW0);
conh(i)=HD0(i)/sum(j,HD0(j));
ratewk=YWK0/TYK0;
ratehe=YEH0/YEK0;

invest(i)=INV0(i)/TINV0;

th=GHTAX0/(TYL0+YHK0+YEH0+YHG0+YHW0);
te=GETAX0/YEK0;
rategw=GWY0/sum(j,QM0(j));
ratehg=YHG0/(sum(j,GTRIFM0(j))+sum(i,GINDTAX0(i))+GHTAX0+ GETAX0+GWY0);
ratewg=YWG0/(sum(j,GTRIFM0(j))+sum(i,GINDTAX0(i))+GHTAX0+GETAX0+GWY0);
savg=SG0/(sum(j,GTRIFM0(j))+sum(i,GINDTAX0(i))+GHTAX0+GETAX0+GWY0);
cong(i)=GD0(i)/sum(j,GD0(j));
QQ0(j)=QD0(j)+QM0(j)+tm(j)*QM0(j);


** ADDED FACTORS OF IRAN SAM

ratehl=YWL0/TYL0;

ratekw=YKW0/TYK0;

ratehh=YHH0/YHT0;

ratehe=EHY0/YEK0;

rateGC=YGC0/YGT0;

tg=GGTAX0/YGT0;

ratelw=YLW0/TYL0;

ratewh=YWH0/sum(i,QM0(i));

rateai=YAI0/sum(i,QM0(i));

**

********** 4.2 Elasticity and Share Parameters Calibration ---------------------
** add gas market parameter

ECON=0.2;

PET=20;

pett=8;

qer=1;

MC=1;

ETA =0.5;

SHARE=0.05 ;

QE0(n)=secda2("gas","QE");

QET0(n)=1;

PREG=0.75;

rateEP=0.2;

EP0=1;

**


parQX(i)=(rhoQX(i)-1)/rhoQX(i);
parKEL(i)=(rhoKEL(i)-1)/rhoKEL(i);
parKE(i)=(rhoKE(i)-1)/rhoKE(i);
parE(i)=(rhoE(i)-1)/rhoE(i);
parPG(i)=(rhoPG(i)-1)/rhoPG(i);
parpetr(i)=(rhopetr(i)-1)/rhopetr(i);
pargas(i)=(rhogas(i)-1)/rhogas(i);
parpow(i)=(rhopow(i)-1)/rhopow(i);

etaQq(i)=(rhoQq(i)-1)/rhoQq(i);
phiCET(i)=(rhoCET(i)+1)/rhoCET(i);

deltaKEL(i)=(KEL0(i)/QX0(i))**(1-parQX(i))*(PX0(i)/PKEL0(i))**(-1);

deltaND(i)=(ND0(i)/QX0(i))**(1-parQX(i))*(PX0(i)/PND0(i))**(-1);

deltaKE(i)=KE0(i)**(1-parKEL(i))*PKE0(i)/(WL0*wldist(i)*L0(i)**(1-parKEL(i))
           +PKE0(i)*KE0(i)**(1-parKEL(i)));

deltaL(i)=1-deltaKE(i);

scaleKEL(i)=KEL0(i)/(deltaKE(i)*KE0(i)**parKEL(i)+deltaL(i)
            *L0(i)**parKEL(i))**(1/parKEL(i));

deltaE(i)=E0(i)**(1-parKE(i))*PE0(i)/(WK0*wrdist(i)*K0(i)**(1-parKE(i))+PE0(i)
          *E0(i)**(1-parKE(i)));

deltaK(i)=1-deltaE(i);

scaleKE(i)=KE0(i)/(deltaE(i)*E0(i)**parKE(i)+deltaK(i)
           *K0(i)**parKE(i))**(1/parKE(i));


deltapg(i)=(Epg0(i)/E0(i))*(PE0(i)/PEpg0(i))**(-1);

deltagas(i)$(Epg0(i)>0)=(Egas0(i)/Epg0(i))**(1-parPG(i))*(PEpg0(i)/PQ0('gas'))**(-1);

deltapetr(i)$(Epg0(i)>0)=(Epetr0(i)/Epg0(i))**(1-parpg(i))*(PEpg0(i)/PQ0('petr'))**(-1);

deltapow(i)$(Egas0(i)>0)=(Epow0(i)/E0(i))**(1-parE(i))*(PE0(i)/PQ0('pow'))**(-1);


deltaQM(j)=(1+tm(j))*QM0(j)**(1-etaQq(j))/(QD0(j)**(1-etaQq(j))+(1+tm(j))*QM0(j)**(1-etaQq(j)));

deltaQD(j)=1-deltaQM(j);

scaleQQ(j)=QQ0(j)/(deltaQM(j)*QM0(j)**etaQq(j)+deltaQD(j)*QD0(j)**etaQq(j))**(1/etaQq(j));

deltaQE(m)=QE0(m)**(1-phiCET(m))/(QD0(m)**(1-phiCET(m))+QE0(m)**(1-phiCET(m)));

deltaQDs(m)=1-deltaQE(m);

scaleCET(m)=QX0(m)/(deltaQE(m)*QE0(m)**phiCET(m)+deltaQDs(m)*QD0(m)**phiCET(m))**(1/phiCET(m));

Display
parQX,
parKEL,
parKE,
parE,
parPG,
parpetr,
pargas,
parpow,

etaQq,
phiCET,

deltaKEL,
deltaND,
deltaKE,
deltaL,
deltaE,
deltaK,

deltapow,

deltapg,

deltapetr,
deltagas,

scaleQQ,
deltaQM,
deltaQD,
scaleCET,
deltaQE,
deltaQDs,
tind,
tm,

YH0
PL0
WL0,
L0,
wldist,

DEPRE0,
YK0,
dept,
K0,
PK0,
WK0,
wrdist,

LHD0,
THD0,
hdye,
frisch,
hds,
mpci,
tmcpi,
mpc;

***********5. Model  System  Definition --------------------------------
************5.1 Variable Definition---------------------------------------------
*****Production function Variable (40)------------------------------------------

Variable

QX(i)           Output of the i-th sector
ND(i)           Intermediate input
UND(oths,i)     Unit intermediate input
KEL(i)          Capital-Energy-Labor composite factor input
KE(i)           Capital-Energy composite factor input
L(i)            Labor factor input
K(i)            Capital factor input

E(i)            Energy composite factor input
Epg(i)          Petr and gas energy composite factor input
Epetr(i)        Petr energy composite factor input
Egas(i)         Gas energy composite factor input
Epow(i)         Power energy composite factor input

PX(i)           Price of the j-th good
PND(i)          Price of the intermediate input
PKEL(i)         Price of the Capital-Energy-Labor composite factor
PKE(i)          Price of the Capital-Energy composite factor

PE(i)           Price of the energy composite factor

PEpg(i)         Price of the petr and gas energy composite factor
PEpetr(i)       Price of the petr energy composite factor
PEgas(i)        Price of the gas energy composite factor

WL              The average price of the labor factor
WK              The average price of the capital factor

******Trade function Variable----------------------------
QQ(i)           Armington's composite good
QD(j)           Armington's domestic good CET's domestic good
QM(j)           Imports good
QE(j)           Exports good
PQ(j)           Armington's composite good price
PD(j)           The i-th domestic good price
PWM(j)          Import price in local currency
PWE(j)          Export price in local currency
EXR             Exchange rate

QET(n)


******Household function Variable----------------------------
YH(i)          the income of household labor income from the i-th sector
TYL            the total income of household from labor
YHK            the total income of household from capital
YHW            the total income of household from foreign
YHT            the total income of household
SH             the saving of household
HDY
LHD
HD(j)          the consumption of household to the j-th good

EP

****** Enterprise function Variable----------------------------
YK(i)          the income of capital from the i-th sector
TYK            the total income from capital
YWK            the income of foreign from capital
YEK            the income of enterprise capital
YEH            the transfer payments of the enterprise to household
SE             the saving of enterprise

****** Government function Variable----------------------------
GINDTAX(i)     the income of government from the i-th sector indirect tax
GTRIFM(j)      the income of government from the j-th good tariff tax
GHTAX          the income of government from household income tax
GETAX          the income of government from enterprise income tax
GWY            the income of government from foreign
YGT            the total income of government
YHG            the transfer payments of government to household
YWG            the payments of government to foreign
SG             the saving of government
GD(j)          the consumption of government to the j-th good

** ADDED FACTORS OF IRAN SAM

YWL

YKW

YHH

EHY

YGC

GGTAX

YLW

YWH

YAI

**

*********Equilibrium function variable----------------
*SF             the saving of foreign(Exogenous)
TINV           the total investing
INV(j)         the saving of the j-th good
TSAV           the total saving
*KS             the total Capital factor supply (Exogenous)
*LS             the total Labor factor supply (Exogenous)
RGDP           the real GDP
SGDP(i)        the nominal GDP of the i-th sector
GDP            the nominal GDP
PGDP           the GDP price index
WALRAS         the walras for checking the modeling balance

***********Welfare function variable-----------------------------
EV              The objective function variable
;

*********5.2 equation definition --------------------------
*********Production function definition(37) --------------------------
Equation
eqND(i)          Intermediate demand function
eqKEL(i)         Capital-Energy-Labor composite factor demand function
eqPX(i)          Price of the j-th sector input

eqUND(oths,i)    Unit intermediate input function
eqPND(i)         Immediate price

eqKE(i)          Capital-Energy composite factor demand function
eqL(i)           Labor factor demand function
eqPKEL(i)        Price of the Capital-Energy-Labor composite factor

eqK(i)           Capital factor demand function
eqE(i)           Energy composite demand function
eqPKE(i)         Price of the Capital-Energy composite factor

eqEpow(i)        Power energy demand function
eqPE(i)          Price of the energy composite factor

eqEpg(t)         Petr and gas compositeenergy demand function

eqEpetr(t)       Petr  compositeenergy demand function
eqEgas(t)        Gas compositeenergy demand function
eqPpg(t)         Price of the petr and gas energy composite factor


*********Trade function definition --------------------------
eqPWM(j)        World import price equation
eqPWE(j)        World export price equation

eqQD(j)         Domestic good demand function for import sector
eqQM(j)         Import demand function for import sector
eqQQ(i)         Arminition function for import sector

eqQDs(m)        Domestic good supply function for export sector
eqQE(m)         Export supply function for export sector
eqQX(m)         Transformation function for export sector

eqQDs2(n)
eqPD2(n)

** ADD GAS MARKET

eqQE2(n)

eqQET(n)

eqPEgas(n)

eqECONPROF(n)

**

******Household function definition ----------------------------
eqYH(i)         the income function of household labor income from the i-th sector
eqTYL           the total income function of household from labor
eqYHK           the total income function of household from capital
eqYHW           the total income function  of household from foreign
eqYHT           the total income function of household
eqSH            the saving of function household
eqHDY
*eqLHD
*eqHD            the consumption function of household to the j-th good

eqLHD
eqHD(nfe)
eqHDpetr
eqHDgas

** ADDED FACTORS OF IRAN SAM


eqYWL

eqYKW

eqYHH

eqEHY

eqYGC

eqGGTAX

eqYLW

eqYWH

eqYAI

**

****** Enterprise function definition ----------------------------
eqYK(i)         the income function of capital from the i-th sector
eqTYK           the total income function from capital
eqYWK           the income function of foreign from capital
eqYEK           the income function of enterprise capital
eqYEH           the transfer payments function of the enterprise to household
eqSE            the saving function of enterprise

****** Government function definition ----------------------------
eqGINDTAX(i)     the income function of government from the i-th sector indirect tax
eqGTRIFM(j)      the income function of government from the j-th good tariff tax
eqGHTAX          the income function of government from household income tax
eqGETAX          the income function of government from enterprise income tax
eqGWY            the income function of government from foreign
eqYGT            the total income function of government
eqYHG            the transfer payments function of government to household
eqYWG            the payments function of government to foreign
eqSG             the saving function of government
*eqGD(j)          the consumption function of government to the j-th good

eqGD(nfe)
eqGDpetr
eqGDgas

**********Equilibrium function definition ----------------
eqFOReqiu        the equilibrium function of International payments
eqTSAV           the total saving function
*eqTINV           the total investing function
*eqINV(j)         the investing function of the j-th good
*eqSIequ          the equilibrium function of saving and investing

eqTINV
eqINV(nfe)
eqINVpetr
eqINVgas
eqSIeq

eqDSequ1         the equilibrium function of need and supply(1-20)
eqDSequ2
eqDSequ3
eqDSequ4
eqDSequ5
eqDSequ6
eqDSequ7
eqDSequ8
eqDSequ9
eqDSequ10
eqDSequ11
eqDSequ12
eqDSequ13
eqDSequ17
eqDSequ19
eqDSequ20

eqKSDequ         the equilibrium function of capital market
eqLSDequ         the equilibrium function of labor market
eqRGDP           the real GDP function
eqSGDP(i)        the nominal GDP function from the i-th sector
eqGDP            the nominal GDP function
eqPGDP           the function of GDP price index

***********Welfare function definition -----------------------------
obj              the welfare function
;

****Production function -----------------
eqND(i)..      ND(i)=e=deltaND(i)**(1/(1-parQX(i)))*(PX(i)/PND(i))**(1/(1-parQX(i)))*QX(i);

eqKEL(i)..     KEL(i)=e=deltaKEL(i)**(1/(1-parQX(i)))*(PX(i)/PKEL(i))
                        **(1/(1-parQX(i)))*QX(i);

eqPX(i)..      QX(i)=e=(deltaKEL(i)*KEL(i)**parQX(i)
                       +deltaND(i)*ND(i)**parQX(i))**(1/parQX(i));

eqUND(oths,i)..UND(oths,i)=e=ca(oths,i)*ND(i);

eqPND(i)..     PND(i)=e=sum(oths,ca(oths,i)*PQ(oths));




eqKE(i)..      KE(i)=e=(scaleKEL(i)**parKEL(i)*deltaKE(i)*PKEL(i)/PKE(i))**
                       (1/(1-parKEL(i)))*KEL(i);

eqL(i)..       WL*wldist(i)=e=PKEL(i)*KEL(i)*(deltaKE(i)*KE(i)**parKEL(i)
               +deltaL(i)*L(i)**parKEL(i))**(-1)*deltaL(i)*L(i)**(parKEL(i)-1);

eqPKEL(i)..    KEL(i)=e=scaleKEL(i)*(deltaKE(i)*KE(i)**parKEL(i)
                        +deltaL(i)*L(i)**parKEL(i))**(1/parKEL(i));




eqE(i)..       E(i)=e=(scaleKE(i)**parKE(i)*deltaE(i)*PKE(i)/PE(i))**(1/(1-parKE(i)))*KE(i);

eqK(i)..       WK*wrdist(i)=e=PKE(i)*KE(i)*(deltaK(i)*K(i)**parKE(i)
               +deltaE(i)*E(i)**parKE(i))**(-1)*deltaK(i)*K(i)**(parKE(i)-1);

eqPKE(i)..     KE(i)=e=scaleKE(i)*(deltaK(i)*K(i)**parKE(i)+deltaE(i)*E(i)
                       **parKE(i))**(1/parKE(i));




eqEpg(t)..    Epg(t)=e=deltapg(t)**(1/(1-parE(t)))*(PE(t)/PEpg(t))**(1/(1-parE(t)))*E(t);

eqEpow(i)..    Epow(i)=e=deltapow(i)**(1/(1-parE(i)))*(PE(i)/(PQ('POW')))**(1/(1-parE(i)))*E(i);

eqPE(i)..      E(i)=e=(deltapg(i)*Epg(i)**parE(i)+deltapow(i)*Epow(i)**parE(i))**(1/parE(i));


eqEpetr(t)..   Epetr(t)=e=deltapetr(t)**(1/(1-parPG(t)))*(PEpg(t)/PQ('Petr'))**(1/(1-parPG(t)))*Epg(t);

eqEgas(t)..    Egas(t)=e=deltagas(t)**(1/(1-parPG(t)))*(PEpg(t)/(PQ('gas')))**(1/(1-parPG(t)))*Epg(t);

eqPpg(t)..     Epg(t)=e=(deltapetr(t)*Epetr(t)**parPG(t)+deltagas(t)*Egas(t)**parPG(t))**(1/parPG(t));

********************************************************************************


*****Trade function----------------------------
eqPWM(j)..     PWM(j)=e=PWM0(j)*EXR;
eqPWE(j)..     PWE(j)=e=PWE0(j)*EXR;

eqQD(j)..      QD(j)=e=(scaleQQ(j)**etaQq(j)*deltaQD(j)
                       *PQ(j)/PD(j))**(1/(1-etaQq(j)))*QQ(j);

eqQM(j)..      QM(j)=e=(scaleQQ(j)**etaQq(j)*deltaQM(j)
                       *PQ(j)/((1+tm(j))*PWM(j)))**(1/(1-etaQq(j)))*QQ(j);

eqQQ(j)..      QQ(j)=e= scaleQQ(j)*(deltaQD(j)
                *QD(j)**etaQq(j)+ deltaQM(j)*QM(j)**etaQq(j))**(1/etaQq(j));


eqQDs(m)..     QD(m)=e=(scaleCET(m)**phiCET(m)*deltaQDs(m)
                       *(1+tind(m))*PX(m)/PD(m))**(1/(1-phiCET(m)))*QX(m);

eqQE(m)..      QE(m)=e=(scaleCET(m)**phiCET(m)*deltaQE(m)
                       *(1+tind(m))*PX(m)/PWE(m))**(1/(1-phiCET(m)))*QX(m);

eqQX(m)..      QX(m)=e=scaleCET(m)*(deltaQDs(m)
               *QD(m)**phiCET(m)+ deltaQE(m)*QE(m)**phiCET(m))**(1/phiCET(m));

eqQDs2(n)..    QD(n)=e=(1+tind(n))*QX(n);

eqPD2(n)..     PD(n)=e=PQ0(n)*(1+tind(n))*(1+PREG);

** add gas market

eqQET(n)..      QET(n)=e=ECON*(PET/pett)**Eta;

eqQE2(n)..      QE(n)=e=QET(n)-qer;

eqPEgas(n)..    PEgas(n)=e=MC/(1-(SHARE/ETA));

eqECONPROF(n).. EP=e=QE(n)*(PEgas(n)-PX(n))+PQ0(n)*(1+tind(n))*(preg*QD(n));
**

******Household function ----------------------------
eqYH(i)..      YH(i)=e=WL*wldist(i)*L(i);
eqTYL..        TYL=e=sum(i,YH(i));
eqYHK..        YHK=e=ratehk*TYK;

** added factors of iran sam

eqYWL..        YWL=e=ratehl*TYL;

eqYHH..        YHH=e=ratehh*YHT;

eqYLW..        YLW=e=ratelw*TYL;

eqYWH..        YWH=e=ratewh*sum(i,QM0(i));

**

eqYHW..        YHW=e=ratehw*sum(j,PWM(j)*QM(j));
eqYHT..        YHT=e=TYL+YHK+YEH+YHG+YHW+YWL+YHH+YLW;
eqSH..         SH=e=savh*YHT;
eqHDY..        HDY=e=YHT-SH-GHTAX;

*eqLHD..        LHD=e=sum(j,LHD0(j)*PQ(j));
*eqHD(j)..      HD(j)*PQ(j)=e=LHD0(j)*PQ(j)+mpc(j)*(HDY-LHD);

eqLHD..  LHD=e=sum(nfe,LHD0(nfe)*PQ(nfe))
               +LHD0('petr')*PQ('petr')
               +LHD0('gas')*PQ('gas');

eqHD(nfe)..  HD(nfe)*PQ(nfe)=e=LHD0(nfe)*PQ(nfe)+mpc(nfe)*(HDY-LHD);
eqHDpetr..  HD('petr')*PQ('petr')=e=LHD0('petr')*PQ('petr')+mpc('petr')*(HDY-LHD);
eqHDgas..   HD('gas')*PQ('gas')=e=LHD0('gas')*PQ('gas')+mpc('gas')*(HDY-LHD);

****** Enterprise function ----------------------------
eqYK(i)..     YK(i)=e=WK*wrdist(i)*K(i);
eqTYK..       TYK=e=sum(i,YK(i));
eqYWK..       YWK=e=ratewk*TYK;
eqYEK..       YEK=e=(1-ratehk-ratewk)*TYK;
eqYEH..       YEH=e=ratehe*YEK;
eqSE..        SE=e=YEK-YEH-GETAX;

**ADDED FACTORS OF IRAN SAM

eqYKW..      YKW=e=ratekw*TYK;

eqEHY..      EHY=e=ratehe*YEH;

eqYAI..      YAI=e=rateai*sum(i,QM0(i));
**

****** Government function ----------------------------
eqGINDTAX(i).. GINDTAX(i)=e=tind(i)*PX(i)*QX(i);
eqGTRIFM(j)..  GTRIFM(j)=e=tm(j)*PWM(j)*QM(j);
eqGHTAX..      GHTAX=e=th*YHT;
eqGETAX..      GETAX=e=te*YEK;
eqGWY..        GWY=e=rategw*sum(j,PWM(j)*QM(j));

** ADDED FACTORS OF IRAN SAM

eqYGC..        YGC=e=rateGC*YGT;

eqGGTAX..      GGTAX=e=tg*YGT;

**

eqYGT..        YGT=e=sum(i,GINDTAX(i))+sum(j,GTRIFM(j))+GHTAX+GETAX+GWY+YGC+GGTAX;
eqYHG..        YHG=e=ratehg*YGT;
eqYWG..        YWG=e=ratewg*YGT;
eqSG..         SG=e=savg*YGT;

*eqGD(j)..    GD(j)=e=cong(j)*(1-ratehg-ratewg-savg)*YGT/PQ(j);
eqGD(nfe).. GD(nfe)=e=cong(nfe)*(1-ratehg-ratewg-savg)*YGT/PQ(nfe);
eqGDpetr.. GD('petr')=e=cong('petr')*(1-ratehg-ratewg-savg)*YGT/PQ('petr');
eqGDgas..  GD('gas')=e=cong('gas')*(1-ratehg-ratewg-savg)*YGT/PQ('gas');

**********Equilibrium function ----------------
eqFOReqiu..   sum(j,PWM(j)*QM(j))+YWK+YWG=e=sum(j,PWE(j)*QE(j))+YHW+GWY+SF0*EXR;

eqTSAV..      TSAV=e=SE+SG+SH+SF0*EXR;

*eqTINV..         TINV=e=TSAV-sum(i,STO(i)*PQ(i));
*eqINV(i)..       INV(i)=e=invest(i)*TINV/PQ(i);
*eqSIequ..        TINV=e=TSAV-sum(i,STO(i)*PQ(i))+WALRAS;

eqTINV..      TINV=e=TSAV;

eqINV(nfe)..  INV(nfe)=e=invest(nfe)*TINV/PQ(nfe);


eqINVpetr.. INV('petr')=e=invest('petr')*TINV/PQ('petr');

eqINVgas..  INV('gas')=e=invest('gas')*TINV/PQ('gas');


eqSIeq..      TINV=e=TSAV+WALRAS;


eqDSequ1..       HD('agric')+GD('agric')+INV('agric')+
                 sum(i,UND('agric',i))=e=QQ('agric');

eqDSequ2..       HD('crudeoil')+GD('crudeoil')+INV('crudeoil')+
                 sum(i,UND('crudeoil',i))=e=QQ('crudeoil');

eqDSequ3..       HD('food ')+GD('food')+INV('food')+
                 sum(i,UND('food',i))=e=QQ('food ');

eqDSequ4..       HD('texti')+GD('texti')+INV('texti')+
                 sum(i,UND('texti',i))=e=QQ('texti');

eqDSequ5..       HD('woodpaper')+GD('woodpaper')+INV('woodpaper')+
                 sum(i,UND('woodpaper',i))=e=QQ('woodpaper');

eqDSequ6..       HD('chemical')+GD('chemical')+INV('chemical')+
                 sum(i,UND('chemical',i))=e=QQ('chemical');

eqDSequ7..       HD('mineral')+GD('mineral')+INV('mineral')+
                 sum(i,UND('mineral',i))=e=QQ('mineral');

eqDSequ8..       HD('metal')+GD('metal')+INV('metal')+
                 sum(i,UND('metal',i))=e=QQ('metal');

eqDSequ9..       HD('machi')+GD('machi')+INV('machi')+
                 sum(i,UND('machi',i))=e=QQ('machi');

eqDSequ10..      HD('commu')+GD('commu')+INV('commu')+
                 sum(i,UND('commu',i))=e=QQ('commu');

eqDSequ11..      HD('const')+GD('const')+INV('const')+
                 sum(i,UND('const',i))=e=QQ('const');

eqDSequ12..      HD('trans')+GD('trans')+INV('trans')+
                 sum(i,UND('trans',i))=e=QQ('trans');

eqDSequ13..      HD('service')+GD('service')+INV('service')+
                 sum(i,UND('service',i))=e=QQ('service');


eqDSequ17..      HD('petr')+GD('petr')+INV('petr')+
                 sum(i,Epetr(i))=e=QQ('petr');

eqDSequ19..      HD('gas')+GD('gas')+INV('gas')+
                 sum(i,Egas(i))=e=QQ('gas');

eqDSequ20..      HD('pow')+GD('pow')+INV('pow')+
                 sum(i,Epow(i))=e=QQ('pow');

eqKSDequ..       sum(i,K(i))=e=KS0;
eqLSDequ..       sum(i,L(i))=e=LS0;

eqRGDP..         RGDP=e=sum(j,HD(j))+sum(j,GD(j))+ sum(j,INV(j))+
                 sum(j,QE(j))-sum(j,QM(j))-sum(j,(GTRIFM(j)/PWM(j)));

eqSGDP(i)..      SGDP(i)=e=WL*wldist(i)*L(i)+WK*wrdist(i)*K(i)+tind(i)*PX(i)*QX(i);
eqGDP..          GDP=e=sum(i,WK*wrdist(i)*K(i))+sum(i,WL*wldist(i)*L(i))+sum(i,tind(i)*PX(i)*QX(i));
eqPGDP..         PGDP=e=GDP/RGDP;


***********Welfare function -----------------------------
obj..        EV=e=sum(j,PQ0(j)*HD(j))-sum(j,PQ0(j)*HD0(j));

***********6.Variable Initialization --------------------
***********6.2 Endogenous Variable Initialization --------------------

QX.l(i)=QX0(i);    ND.l(i)=ND0(i);    UND.l(oths,i)= UND0(oths,i);
KEL.l(i)=KEL0(i);  KE.l(i)=KE0(i);    L.l(i)=L0(i);       K.l(i)=K0(i);
E.l(i)=E0(i);
      Epg.l(i)=Epg0(i);

Epetr.l(i)=Epetr0(i);    Egas.l(i)=Egas0(i);       Epow.l(i)=Epow0(i);

Epow.l(i)=Epow0(i);


PX.l(i)=PX0(i);          PND.l(i)=PND0(i);
PKEL.l(i)=PKEL0(i);      PKE.l(i)=PKE0(i);         WL.l=WL0;    WK.l=WK0;
PE.l(i)=PE0(i);
PEpg.l(i)=PEpg0(i);      EP.l=EP0;


QQ.l(j)=QQ0(j);   QD.l(j)=QD0(j);   QM.l(j)=QM0(j);      QE.l(j)=QE0(j);
PQ.l(j)=PQ0(j);   PD.l(j)=PD0(j);   PWM.l(j)=PWM0(j);    PWE.l(j)=PWE0(j);
EXR.l=EXR0;

YH.l(i)=YH0(i);   TYL.l=TYL0;    YHK.l=YHK0;   YHW.l=YHW0;
YHT.l=YHT0;       SH.l=SH0;      SH.l=SH0;     HD.l(j)=HD0(j);
*LHD.l=LHD0;      HDY.l=HDY0;

YK.l(i)=YK0(i);   TYK.l=TYK0;    YWK.l=YWK0;   YEK.l=YEK0;
YEH.l=YEH0;       SE.l=SE0;
*STO.l(i)=STO0(i);

GINDTAX.l(i)=GINDTAX0(i);     GTRIFM.l(j)=GTRIFM0(j);     GHTAX.l =GHTAX0;
GETAX.l=GETAX0;               GWY.l=GWY0;                 YGT.l=YGT0;
YHG.l=YHG0;                   YWG.l=YWG0;                 SG.l=SG0;
GD.l(i)=GD0(i);

TINV.l=TINV0;       INV.l(j)=INV0(j);        TSAV.l=TSAV0;
RGDP.l=RGDP0;       SGDP.l(i)=SGDP0(i);      GDP.l=GDP0;
PGDP.l=PGDP0;       WALRAS.l=WALRAS0;

*KS.fx=KS0;
*LS.fx=LS0;

Model LCCGE /all/;

OPTION   ITERLIM=4000;
OPTION   RESLIM=4000;
OPTION   SOLPRINT=OFF;
OPTION   DECIMALS=4;

LCCGE.holdfixed=1;
option mcp=path;
Solve LCCGE using mcp;


display
YH0
PL0
WL0,
L0,
wldist,

DEPRE0,
YK0,
dept,
K0,
PK0,
WK0,
wrdist,


QX.l,  ND.l, UND.l,
KEL.l, KE.l,    L.l, K.l,
E.l,
    Epg.l,
Epetr.l,   Egas.l,      Epow.l,
Epow.l,

PX.l,        PND.l,
PKEL.l,      PKE.l,        WL.l,     WK.l,
PE.l,
PEpg.l,

QQ.l,  QD.l,   QM.l,   QE.l,    EP.l,
PQ.l,  PD.l,   PWM.l,  PWE.l,   EXR.l,

YH.l,    TYL.l,      YHK.l,     YHW.l,
YHT.l,   SH.l,       HDY.l,     LHD.l,    HD.l,

YK.l,    TYK.l,      YWK.l,         YEK.l,
YEH.l,   SE.l,

GINDTAX.l,     GTRIFM.l,     GHTAX.l ,
GETAX.l,       GWY.l,        YGT.l,
YHG.l,         YWG.l,        SG.l,       GD.l,

TINV.l,     INV.l,       TSAV.l,
RGDP.l,     SGDP.l,      GDP.l,      PGDP.l,
EV.l,       WALRAS.l ;


execute_unload "Results",

QX.l,  ND.l, UND.l,
KEL.l, KE.l,    L.l, K.l,
E.l,
   Epg.l,
Epetr.l,   Egas.l,      Epow.l,
Epow.l,

PX.l,        PND.l,
PKEL.l,      PKE.l,        WL.l,     WK.l,
PE.l,
PEpg.l,

QQ.l,  QD.l,   QM.l,   QE.l,    EP.l,
PQ.l,  PD.l,   PWM.l,  PWE.l,   EXR.l,

YH.l,    TYL.l,      YHK.l,     YHW.l,
YHT.l,   SH.l,       HDY.l,     LHD.l,    HD.l,

YK.l,    TYK.l,      YWK.l,         YEK.l,
YEH.l,   SE.l,

GINDTAX.l,     GTRIFM.l,     GHTAX.l ,
GETAX.l,       GWY.l,        YGT.l,
YHG.l,         YWG.l,        SG.l,       GD.l,

TINV.l,     INV.l,       TSAV.l,
RGDP.l,     SGDP.l,      GDP.l,      PGDP.l,
EV.l,       WALRAS.l

;

Execute '=gdx2xls results.gdx';

